varying float time;
varying float xcoord,ycoord,zcoord;
varying vec2 Texcoord;
void main()
{
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;	
	
	//Texture Coordinates
	xcoord = gl_Vertex.x;
	zcoord = gl_Vertex.z;
	ycoord = gl_Vertex.y ;
	
	// projection1. y is largest normal component
	// so use x and z to sample texture
	 gl_TexCoord[0] = vec4(xcoord/8.0,zcoord/8.0,0.0,0.0); //first projection
	// projection2. x is largest normal component
	// so use z and y to sample texture
	 gl_TexCoord[1] = vec4(zcoord/8.0,ycoord/8.0,0.0,0.0); //second projection
	// projection3. z is largest normal component
	// so use x and y to sample texture
	 gl_TexCoord[2] = vec4(xcoord/8.0,ycoord/8.0,0.0,0.0); //third projection
	
	float x = abs(gl_Normal.x);
	float y = abs(gl_Normal.y);
	float z = abs(gl_Normal.z);
	
	Texcoord = gl_TexCoord[0].st;
	if(x > y && x > z || x == z && x > y)
	{
		Texcoord = gl_TexCoord[1].st;
	}
	if(z > y && z > x)
	{
		Texcoord = gl_TexCoord[2].st;
	} 
			
	gl_Position = ftransform();
}
